indexing
	description: "A basic 2d texture with render to texture support, ..."
	date: "$Date: Jul 9, 2006 9:31:16 AM$"
	revision: "$Revision: 1.0$"

class EM3D_TEXTURE_2D[F -> EMGL_FORMAT create default_create end]

inherit
	EMGLU_TEXTURE_2D[F]

	EM_CONSTANTS
		export {NONE} all
		undefine default_create end

	GLEXT_FUNCTIONS_EXTERNAL
		export {NONE} all
		undefine default_create end

	GLEW_FUNCTIONS
		export {NONE} all {ANY} is_supported
		undefine default_create end

	EMGLU_FUNCTIONS
		export {NONE} all
		undefine default_create end

	EM_SHARED_SUBSYSTEMS
		export {NONE} all
		undefine default_create end

	EM3D_RESOURCE
		export {NONE} all
		undefine default_create end
create
	make_empty,
	make_empty_mipmap,
	make_from_surface,
	make_from_surface_stretched,
	make_mipmap_from_surface,
	make_mipmap_from_surface_with_border,
	make_mipmap_from_surface_stretched,
	make_mipmap_from_surface_with_border_stretched

feature {NONE} -- Initialization

	make_empty_mipmap( width, height: INTEGER ) is
			-- Create a new EM3D_TEXTURE_2D object.
			-- Empty Midmap only available if framebuffer_objects are supported
		require
			extension_is_avialbe: is_supported( "GL_EXT_framebuffer_object" )
		do
			if not is_supported( "GL_EXT_framebuffer_object" ) then
				Error_handler.raise_error (Error_codes.Em_error_em3d_texture, ["Empty mipmap: framebuffer objects not supported!"])
			end

			make_empty( width, height )
			generate_mipmap
			is_mipmap:=true
		end

feature {EM3D_TEXTURE_2D} -- Internal commands

	generate_mipmap_internal is
			-- Make the current texture to a mipmap
		require
			extension_is_avialbe: is_supported( "GL_EXT_framebuffer_object" )
		do
			gl_generate_mipmap_ext_external( target )
		end

feature -- Commands

	generate_mipmap is
			-- Make the current texture to a mipmap
		require
			extension_is_avialbe: is_supported( "GL_EXT_framebuffer_object" )
		do
			bind_and_save_old
			gl_generate_mipmap_ext_external( target )
			bind_old_id
		end

	attach_to_framebuffer( attachment:INTEGER; fbo: EMGL_FRAME_BUFFER ) is
			-- attach the texture to a framebuffer
			-- attachment is the point where the texture is atatched to the buffer:
			-- em_gl_color_attachment0_ext ... em_gl_color_attachmentn_ext (where n is from 0 to em_gl_max_color_attachments_ext-1)
			-- em_gl_depth_attachment_ext
	        -- em_gl_stencil_attachment_ext
		do
			fbo.texture2d( attachment, target, texture_id, 0 )
		end

end -- class EM3D_TEXTURE_2D
